# define _GNU_SOURCE
# include <stdio.h>
# include <stdarg.h>
# include "buf.h"

/*
  Initialize our buffer struc
*/
void buf_init( BUFFER *b )
{
	/* Strip everything that we have */
	b->buf = NULL;
	b->size = 0;
	b->no_of_times_malloced = 0;
	b->tag = 0;
}

/*
  free the buffer with all those mem checks ..... our struc makes it so zimple ;)
*/
void buf_free(BUFFER *b)
{
	/*if its already free then y free it again? ;)*/
	if ( b->no_of_times_malloced > 0 )
	{
		free( b->buf );
		b->size = 0;
		/*this one helps us keep track of no of times allocated/freed and shit!*/
		b->no_of_times_malloced -= 1;
		b->buf = NULL;
		b->tag = 0;
	}
}

/*
  allocate memory for the specified size ..... 
  Actually we dont need this one ..... but this is for those who would CRIB about no malloc.... no freedom... blah blah...yawn!! TAKE IT!!
*/
int buf_malloc( BUFFER *b, MAH_SIZE size )
{
	if( b->no_of_times_malloced > 0 )
		buf_free( b );

	b->buf = (char *)malloc( size );
	if ( b->buf == NULL )
	{
		return ERR_BUF_MALLOC;
	}
	b->size = size;
	b->no_of_times_malloced += 1;
	return 0;
}


int buf_realloc( BUFFER *b, MAH_SIZE new_size )
{
	char *temp;
	temp = NULL;

	if ( new_size > b->size )
	{
		/* if u have not yet malloced and realloc it acts as malloc ..... 
		   i find this a gr8 feature maan!
		 */
		temp = (char *)realloc( b->buf , new_size + 1);
		/*Now u c y u need temp and not just b->buf = realloc( b->buf , new_size + 1) */
		if ( temp == NULL )
		{
			/*apna error code ;)*/
			return ERR_BUF_REALLOC;
		}
	       	b->buf = temp;
		b->size = new_size;
		b->no_of_times_malloced += 1;
 	}
	return 0;
}

int buf_clear( BUFFER *b )
{
	memset( b->buf, 0, b->size );
	return 0;
}

int buf_copy( BUFFER *b, const char *src, MAH_SIZE size )
{
	int ret;

	if ( size <= 0 )
	{
		return 0;
	}	
	
	/*Now if it is a copy then no orginal data be retained ..... FREE the fucker if he has been already allocated memory :)*/
	if ( b->no_of_times_malloced > 0 )
	{
		buf_free( b );
	}
	ret = buf_realloc( b, size );
	if ( ret != 0 )
	{
		return ret;
	}
	memcpy( &b->buf[0] , src, size );
	/*the '\0' paranoia for strings
	  somehow i need to firgure this out .... the below shud be (size - 1) as arrary size is SIZE so last accessible member shud be -1
	  but how come even SIZE works :D ? puhlllllllllllllllleaz explain
	 */
	b->buf[ size ] = '\0';
	return 0;
}


int buf_cat( BUFFER *b, const char *src, MAH_SIZE size  )
{
	int ret;
	MAH_SIZE temp_size;
	
	/* SIZE is zero then nothin to do in life ... quit*/
	if ( size == 0 )
		return ERR_ZERO_SIZE;
	
//	if ( src == NULL)
//		return 0;
	temp_size = b->size;
	/* u need more SPACE huh ?*/
	ret = buf_realloc( b, size + temp_size );
	if ( ret != 0 )
	{
		return ret;
	}
	
	memcpy( &b->buf[ temp_size ], src, size );
	b->buf[ b->size ] = '\0';
	
	return 0;
}

/*This is yet to completed .... dont use this function as of now*/
BUFFER explode ( BUFFER b, int start, int size, char tok)
{
	int i, found = 0;
	BUFFER result;
	
	buf_init(  &result );
	if ( size == 0 ) 
		size = b.size;
	for (i=0; i < size; i++ )
	{
		if ( b.buf[i+start] == tok)
		{
			found = 1;
			buf_copy( &result, &b.buf[start], i - 1 );
			result.tag = 0;
		}
	}
	if ( found == 0)
	{
		buf_copy( &result, b.buf, size );
		result.tag = 1;
	}
	return ( result );	
}


int buf_printf_copy( BUFFER *b, const char *print_message, ... ) 
{
	char *temp;
	int ret, ret_copy;
	va_list argptr;
	
	va_start( argptr, print_message );
	ret = vasprintf( &temp, print_message,  argptr );
	va_end( argptr );

	if ( ret == -1 ) 
	{
		return ERR_PRINTF_MALLOC_COPY;
	}
	
	ret_copy = buf_copy( b, temp, ret );
	
	free( temp );

	if ( ret_copy != 0 )
	{
		return ret_copy;
	}
	
	return 0;
}



int buf_printf_cat( BUFFER *b, const char *print_message, ... ) 
{
	char *temp;
	int ret, ret_copy;
	va_list argptr;
	
	va_start( argptr, print_message );
	ret = vasprintf( &temp, print_message,  argptr );
	va_end( argptr );

	if ( ret == -1 ) 
	{
		return ERR_PRINTF_MALLOC_CAT;
	}
	
	ret_copy = buf_cat( b, temp, ret );
	
	free( temp );

	if ( ret_copy != 0 )
	{
		return ret_copy;
	}
	
	return 0;
}
