/* buf.c */
# define MAH_SIZE               unsigned int

typedef struct
{
	char *buf;
	MAH_SIZE size;
	int no_of_times_malloced;
	int tag;
}BUFFER;


void buf_init(BUFFER *b);
void buf_free(BUFFER *b);
int buf_malloc( BUFFER *b, MAH_SIZE size );
int buf_realloc( BUFFER *b, MAH_SIZE new_size );
int buf_clear( BUFFER *b );
int buf_copy( BUFFER *b, const char *src, MAH_SIZE size );
int buf_cat( BUFFER *b, const char *src, MAH_SIZE size  );
int buf_printf_copy( BUFFER *b, const char *print_message, ... );
int buf_printf_cat( BUFFER *b, const char *print_message, ... );
BUFFER explode( BUFFER b, int start, int size, char tok);


/* err.c */
# define ERR_BUF_MALLOC 1
# define ERR_BUF_REALLOC 2
# define ERR_ZERO_SIZE 3
# define ERR_PRINTF_MALLOC_COPY 4
# define ERR_PRINTF_MALLOC_CAT  5

char *error_string( int code );
